<?php
namespace Teknisa\PLA\Modules\Medicao\Controllers;

use \Zeedhi\Framework\DTO\Response;
use \Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use \Setforms2\Shared\ORM\DateTime;

class Pla01010RateioController extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $parameterBagColumns = array();
    protected $environment;
    protected $entityManager;
    protected $dataSourceManager;
    protected $rateioService;

    public function __construct($crudService, $parameterBag, $environment, $entityManager, $dataSourceManager, $rateioService) {
        $this->crudService       = $crudService;
        $this->parameterBag      = $parameterBag;
        $this->environment       = $environment;
        $this->entityManager     = $entityManager;
        $this->dataSourceManager = $dataSourceManager;
        $this->rateioService     = $rateioService;
    }

    public function verifApurac(Request $request, Response $response) {
        try {
            $this->parameterBagColumns = array('CDFILIAL', 'CDSERVFILI', 'DTINICIAL', 'DTFINAL', 'NRORG');
            $filterCriteria = $request->getFilterCriteria();
            $filterCriteria->setDataSourceName('pla01010_verifApurac');

            $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
            $this->crudService->find($response, $newFilterCriteria);
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), 1));
        }
    }

    public function getEfetCli(Request $request, Response $response) {
        try {
            $filterCriteria = $request->getFilterCriteria();
            
            $filterCriteria->setDataSourceName('pla01010_efetCli');
            $this->parameterBagColumns = array('CDFILIAL', 'CDSERVFILI','CDSERVPLAN', 'DTINICIAL', 'DTFINAL', 'NRORG');
            $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
            $this->crudService->find($response, $newFilterCriteria);
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), 1));
        }
    }
    public function getServCli(Request $request, Response $response) {
        try {
            $row = $request->getRow();
            
            $conditions = array(
                array (
                    "columnName" => "CDSERVFILI",
                    "operator" => "=",
                    "value" => $row["CDSERVFILI"]
                ),
                array (
                    "columnName" => "DTINICIAL",
                    "operator" => "=",
                    "value" => $row["DTINICIAL"]
                ),
                array (
                    "columnName" => "DTFINAL",
                    "operator" => "=",
                    "value" => $row["DTFINAL"]
                ),
                array (
                    "columnName" => "CDFILIAL",
                    "operator" => "=",
                    "value" => $row["CDFILIAL"]
                ),
                array (
                    "columnName" => "NRORG",
                    "operator" => "=",
                    "value" => $row["NRORG"]
                )
            );
            $filterCriteria = new FilterCriteria('pla01010_getServFat', $conditions);
            $this->parameterBagColumns = array('CDFILIAL', 'CDSERVFILI', 'DTINICIAL', 'DTFINAL', 'NRORG');
            $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
            $servicos = $this->dataSourceManager->findBy($newFilterCriteria)->getRows();
            $servCli = array();
            $this->parameterBagColumns = array('CDFILIAL', 'CDSERVFILI','CDSERVPLAN', 'DTINICIAL', 'DTFINAL', 'NRORG');

            foreach ($servicos as $servfat) {
                $conditions = array(
                    array (
                        "columnName" => "CDSERVPLAN",
                        "operator" => "=",
                        "value" => $row["CDSERVFILI"]
                    ),
                    array (
                        "columnName" => "CDSERVFILI",
                        "operator" => "=",
                        "value" => $servfat["CDSERVICFATURAM"]
                    ),
                    array (
                        "columnName" => "DTINICIAL",
                        "operator" => "=",
                        "value" => $row["DTINICIAL"]
                    ),
                    array (
                        "columnName" => "DTFINAL",
                        "operator" => "=",
                        "value" => $row["DTFINAL"]
                    ),
                    array (
                        "columnName" => "CDFILIAL",
                        "operator" => "=",
                        "value" => $row["CDFILIAL"]
                    ),
                    array (
                        "columnName" => "NRORG",
                        "operator" => "=",
                        "value" => $row["NRORG"]
                    )
                );
                $filterCriteria = new FilterCriteria('pla01010_efetCli', $conditions);
                $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
                $clientes = $this->dataSourceManager->findBy($newFilterCriteria)->getRows();
                $servCli[$servfat["CDSERVICFATURAM"]]["rows"] = $clientes;
                $servCli[$servfat["CDSERVICFATURAM"]]["changed"] = false;
            }
            $dataSet = new DataSet('pla01010_getServFat', $servCli);
            $response->addDataSet($dataSet);
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), 1));
        }
    }

    public function getEfetPla(Request $request, Response $response) {
        try {
            $filterCriteria = $request->getFilterCriteria();
            
            $filterCriteria->setDataSourceName('pla01010_efetPla');
            $this->parameterBagColumns = array('CDFILIAL', 'CDSERVFILI', 'DTINICIAL', 'DTFINAL', 'NRORG');
            $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
            $this->crudService->find($response, $newFilterCriteria);
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), 1));
        }
    }

    public function getServFat(Request $request, Response $response) {
        try {
            $filterCriteria = $request->getFilterCriteria();
            
            $filterCriteria->setDataSourceName('pla01010_getServFat');
            $this->parameterBagColumns = array('CDFILIAL', 'CDSERVFILI', 'DTINICIAL', 'DTFINAL', 'NRORG');

            $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
            $this->crudService->find($response, $newFilterCriteria);
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), 1));
        }
    }

    public function salvaEfetFat(Request\DataSet $request, Response $response) {
        try {
            $clientes = $request->getDataSet()->getRows();
            $this->entityManager->getConnection()->beginTransaction();

            foreach ($clientes as $cliente) {
                $cdfilial     = $cliente["CDFILIAL"];
                $cdcliente    = $cliente["CDCLIENTE"];
                $cdservfili   = $cliente["CDSERVFILI"];
                $qtcomefetcli = $cliente["TOTALEFET"];
                $cdservplan   = ($cliente["CDSERVPLAN"]);
                $dtefetclie   = $this->toDateTime($cliente["DTEFETCLIE"]);
                $efetclie     = $this->rateioService->findEfetclie($cdfilial, $cdservfili, $dtefetclie, $cdcliente, $cdservplan);

                if (!isset($efetclie)) {
                    $this->rateioService->insertEfetclie($cdfilial, $cdservfili, $dtefetclie, $cdcliente, $cdservplan, $qtcomefetcli);
                } else {
                    $this->rateioService->editEfetclie($efetclie, $qtcomefetcli);
                }
            }
            $this->entityManager->flush();
            $this->entityManager->getConnection()->commit();
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), 1));
        }
    }

    public function toDateTime($date) {
        if (is_string($date)) {
            $explode = explode('/', $date);
            $date = new DateTime($explode[2].'-'.$explode[1].'-'.$explode[0]);
        }
        return $date;
    }
}